<?php
namespace Odhen\API\Util;

class Database {

    protected $util;
    protected $tipoBanco;

    public function __construct(\Odhen\API\Util\Util $util) {
        $this->util = $util;
        $this->tipoBanco = $this->util->getXMLParameter('connection_params');
        $this->tipoBanco = $this->tipoBanco['driver'];
    }

    const ORACLE = 'oci8';

    public function databaseIsOracle() {
        return $this->tipoBanco == self::ORACLE;
    }

    public function convertToDate($dateString) {        
        return \DateTime::createFromFormat('!d/m/Y', explode(' ', $dateString)[0]);
    }

    public function convertToDateTime($dateString) {
        if (self::databaseIsOracle()) {
            $date = \DateTime::createFromFormat('d/m/Y H:i:s', $dateString);
            return $date->format('d/m/Y H:i:s');
        } else {
            return \DateTime::createFromFormat('d/m/Y H:i:s', $dateString);
        }
    }

    public function convertToDateGeneric($format, $dateString) {
    	return \DateTime::createFromFormat($format, $dateString);
    }

    public function getCurrentDateTime() {
        if (self::databaseIsOracle()) {
            $date = \DateTime::createFromFormat('d/m/Y H:i:s', date('d/m/Y H:i:s'));
            return $date->format('d/m/Y H:i:s');
        } else {
            return \DateTime::createFromFormat('d/m/Y H:i:s', date('d/m/Y H:i:s'));
        }
    }

    public function getCurrentDate() {
        $date = \DateTime::createFromFormat('d/m/Y', date('d/m/Y'));
        return $date->format('d/m/Y');
    }

    public function dateTimeToString($date){
        $dateString = $date->format('d/m/Y H:i:s');
        return $dateString;
    }

    public function dateToString($date){
        $dateString = $date->format('d/m/Y');
        return $dateString;
    }

}