<?php

namespace Zeedhi\PaymentPlatform\examples;

$ds = DIRECTORY_SEPARATOR;

require_once __DIR__.$ds.'..'.$ds.'..'.$ds.'vendor'.$ds.'autoload.php';

use Zeedhi\PaymentPlatform\Implementations\SoftwareExpress\PaymentImpl;
$paymentPlatform = PaymentImpl::factory("87F0C974AD999A326B0DDA922B30F6925AF479AD9F56B7649335CC2FC785C26B", "teknisa", PaymentImpl::SANDBOX);

use Zeedhi\PaymentPlatform\NonInstantBuy\NonInstantBuyPlatform;
use Zeedhi\PaymentPlatform\NonInstantBuy\NonInstantBuyTransaction;

use Zeedhi\PaymentPlatform\Address;
use Zeedhi\PaymentPlatform\Customer;
use Zeedhi\PaymentPlatform\CreditCard;

class Order {

    private $paymentPlatform;

    public function __construct(NonInstantBuyPlatform $paymentPlatform) {
        $this->paymentPlatform = $paymentPlatform;
    }

    public function createOrder($value, $transactionId, CreditCard $creditCard, Customer $customer){
        $transaction = new NonInstantBuyTransaction($value, $transactionId, $creditCard, $customer);
        $nit = $this->paymentPlatform->nonInstantBuyTransaction($transaction);
        var_dump($nit);
        $order = $this->paymentPlatform->captureTransaction($nit);
        var_dump($order);
    }
}

/**
 * Data criada apenas para rodar no mês/ano atual
 */
$currentMonth = date("m");
$currentYear = substr(date("Y"), 2);

/**
 * Instância da classe Order
 */
 $order = new Order($paymentPlatform);

 /**
  * Criação do objeto customer com o ID do usuário.
  */
$customer = new Customer();


/**
 * Use as informações do cartão de crédito fornecido para montar o objeto creditcard
 */
$holderName = "Stephen Vincent Strange";
$numbers = "4000000000000044";
$expDateMonth = $currentMonth;
$expDateYear = $currentYear;
$cvv = "123";
$flag = "Visa";
$creditCard = new CreditCard($holderName, $numbers, $expDateMonth, $expDateYear, $cvv, $flag);

$value = "500"; //Valor em centavos
$transactionId = "0666"; //id da transaçã


$transactionKey = $order->createOrder($value, $transactionId, $creditCard, $customer);
var_dump($transactionKey);
