<?php

namespace Zeedhi\PaymentPlatform\examples;

$ds = DIRECTORY_SEPARATOR;

require_once __DIR__.$ds.'..'.$ds.'..'.$ds.'vendor'.$ds.'autoload.php';

use Zeedhi\PaymentPlatform\Implementations\SoftwareExpress\PaymentImpl;
$paymentPlatform = PaymentImpl::factory("87F0C974AD999A326B0DDA922B30F6925AF479AD9F56B7649335CC2FC785C26B", "teknisa", PaymentImpl::SANDBOX);
use Zeedhi\PaymentPlatform\InstantBuy\InstantBuyPlatform;
use Zeedhi\PaymentPlatform\InstantBuy\InstantBuyTransaction;

use Zeedhi\PaymentPlatform\Address;
use Zeedhi\PaymentPlatform\Customer;
use Zeedhi\PaymentPlatform\CreditCard;

class Order {

    private $paymentPlatform;

    public function __construct(InstantBuyPlatform $paymentPlatform) {
        $this->paymentPlatform = $paymentPlatform;
    }

    public function createInstantBuy(CreditCard $creditCard, Customer $customer){
        return $this->paymentPlatform->createToken($creditCard, $customer);
    }

    public function createOrder($value, $transactionId, $instantBuy, $flag, Customer $customer){
        $transaction = new InstantBuyTransaction($value, $transactionId, $instantBuy, $customer);
        $transaction->setFlag($flag);
        $nit = $this->paymentPlatform->instantBuyTransaction($transaction);
        var_dump($nit);
    }

}

/**
 * Data criada apenas para rodar no mês/ano atual
 */
$currentMonth = date("m");
$currentYear = substr(date("Y"), 2);

/**
 * Instância da classe Order
 */
$order = new Order($paymentPlatform);

 /**
  * Criação do objeto customer com o ID do usuário.
  */
$customer = new Customer();
$customer->setId('123');

/**
 * Use as informações do cartão de crédito fornecido para montar o objeto creditcard
 */
$holderName = "Stephen Vincent Strange";
$numbers = "4000000000000044";
$expDateMonth = $currentMonth;
$expDateYear = $currentYear;
$cvv = "123";
$flag = CreditCard::FLAG_VISA;
$creditCard = new CreditCard($holderName, $numbers, $expDateMonth, $expDateYear, $cvv, $flag);

/**
 * Criação do token 
 * A classe Order é usada para chamar o método createToken da plataforma de pagamento
 * Os paramêtros são os objetos creditCard e customer
 */
$instantBuyAndCostumerId = $order->createInstantBuy($creditCard, $customer);
var_dump($instantBuyAndCostumerId);

/**
 * Transação a ser realizada com o token do cartão.
 */
$value = "122"; //valor em centavos
$transactionId = "123456789"; //id da transação
$flag = CreditCard::FLAG_VISA; //bandeira do cartão de crédito

$customer = new Customer();
$customer->setId($instantBuyAndCostumerId["CustomerId"]); //ID do usuário utilizado no passo de criação do token
$instantBuyKey = $instantBuyAndCostumerId["InstantBuyKey"]; //Token do usuário utilizado no passo de criação do token

$transactionKey = $order->createOrder($value, $transactionId, $instantBuyKey, $flag, $customer);