function RestrictValueService(Query, ValueRestrictionsRepository, UnrestrictedFamiliesRepository, AddValueRestrictionRepository, UpdateValueRestrictionRepository, DeleteValueRestrictionRepository){

    this.getValueRestrictions = function(CDFILIAL, CDCLIENTE, CDCONSUMIDOR){
        var query = Query.build()
                        .where('CDFILIAL').equals(CDFILIAL)
                        .where('CDCLIENTE').equals(CDCLIENTE)
                        .where('CDCONSUMIDOR').equals(CDCONSUMIDOR);
        return ValueRestrictionsRepository.download(query);
    };

    this.getUnrestrictedFamilies = function(CDFILIAL, CDCLIENTE, CDCONSUMIDOR){
        var query = Query.build()
                        .where('CDFILIAL').equals(CDFILIAL)
                        .where('CDCLIENTE').equals(CDCLIENTE)
                        .where('CDCONSUMIDOR').equals(CDCONSUMIDOR);
        return UnrestrictedFamiliesRepository.download(query);
    };

    this.addValueRestriction = function(CDFILIAL, CDCLIENTE, CDCONSUMIDOR, CDFAMILISALD, VRCONSDIARAL){
        var query = Query.build()
                        .where('CDFILIAL').equals(CDFILIAL)
                        .where('CDCLIENTE').equals(CDCLIENTE)
                        .where('CDCONSUMIDOR').equals(CDCONSUMIDOR)
                        .where('CDFAMILISALD').equals(CDFAMILISALD)
                        .where('VRCONSDIARAL').equals(VRCONSDIARAL);
        return AddValueRestrictionRepository.download(query);
    };

    this.updateValueRestriction = function(CDFILIAL, CDCLIENTE, CDCONSUMIDOR, CDFAMILISALD, VRCONSDIARAL){
        var query = Query.build()
                        .where('CDFILIAL').equals(CDFILIAL)
                        .where('CDCLIENTE').equals(CDCLIENTE)
                        .where('CDCONSUMIDOR').equals(CDCONSUMIDOR)
                        .where('CDFAMILISALD').equals(CDFAMILISALD)
                        .where('VRCONSDIARAL').equals(VRCONSDIARAL);
        return UpdateValueRestrictionRepository.download(query);
    };

    this.deleteValueRestriction = function(CDFILIAL, CDCLIENTE, CDCONSUMIDOR, CDFAMILISALD){
        var query = Query.build()
                        .where('CDFILIAL').equals(CDFILIAL)
                        .where('CDCLIENTE').equals(CDCLIENTE)
                        .where('CDCONSUMIDOR').equals(CDCONSUMIDOR)
                        .where('CDFAMILISALD').equals(CDFAMILISALD)
        return DeleteValueRestrictionRepository.download(query);
    };

};

Configuration(function(ContextRegister){
    ContextRegister.register('RestrictValueService', RestrictValueService);
});